



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++字符串指针与字符数组的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++字符串指针与字符数组的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 15:01:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><pre class="prettyprint linenums">今天发现这样一个问题</pre>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;
using namespace std;
int main()
{
    ];
    strcpy_s(ch1,");//编译通过
    ];
    strcpy_s(p,");//报错：不接受2个参数
}</pre>
</div>
<p>改成如下所示就没有问题：</p>
<div>
<pre class="prettyprint linenums">strcpy_s(p,,");//编译通过</pre>
</div>
<p>为什么会这样呢？</p>
<p>先看下字符数组与字符串指针的区别：</p>
<p>1.由双引号括起来的字符串常量属于静态存储类型，它被存储在内存的静态存储区内，所以无论字符串常量出现在程序的什么地方，它在程序的整个运行过程中只存储一份。</p>
<p>如果用字符串常量初始化<b>字符数组</b>，就是从静态存储区把整个字符串复制给数组。例如：</p>
<div>
<pre class="prettyprint linenums">char a[] = "hello";</pre>
</div>
<p>如果用字符串常量初始化字符指针，就是把字符串在静态存储区的地址复制给指针。例如：</p>
<div>
<pre class="prettyprint linenums">char *p = "world";</pre>
</div>
<p>这两种形式的一个重要<b>区别</b>是不能通过指针来修改字符串的值，但是<b>字符数组</b>不存在这个问题，如</p>
<p>语句是错误的：</p>
<div>
<pre class="prettyprint linenums">p[] = 'p';</pre>
</div>
<p>而如下语句没有问题：</p>
<div>
<pre class="prettyprint linenums">a[] = 'a';</pre>
</div>
<p>为了避免通过指针修改字符串的错误，建议将字符指针声明为const类型，如下所示：</p>
<div>
<pre class="prettyprint linenums">const char *p = "world";</pre>
</div>
<p>例如：</p>
<div>
<pre class="prettyprint linenums">.int  main()
 {
  ]="hello world!";     //char *str1="hello world!";
  str1[]='A';                      //若str1是指针型的，编译通过，但运行是此处会段错误
 printf("%s\n",str1);
  ;
 }</pre>
</div>
<p>2.数组和指针都可以在它们的定义中用字符串常量进行初始化，尽管看上去一样，底层的实现机制却不相同。</p>
<p>定义指针时，编译器并不为指针所指向的对象分配空间，它只是分配指针本身的空间，除非在定义的同时赋值给指针一个字符串常量进行初始化。例如：下面的定义创建了一个字符串常量（为其分配了内存）：</p>
<div>
<pre class="prettyprint linenums">char *p=”abcdefg”;</pre>
</div>
<p>注意只有对字符串常量才是如此，不能指望为浮点数之类的常量分配空间，如：</p>
<div>
<pre class="prettyprint linenums">Float *p=2.34;  /*错误，无法通过编译*/</pre>
</div>
<p>下面结合一个实例谈谈初始化指针时创建的字符串常量与数组中的字符串的区别：</p>
<ol><li>在ANSI C中，初始化指针时所创建的字符串常量被定义为只读。如果试图通过指针修改这个字符串的值，程序就会出现未定义的行为。在有些编译器中，字符串常量被存放在只允许读取的文本段中，以防止它被修改。</p>
<li>数组也可以用字符串常量进行初始化：
<div>
<pre class="prettyprint linenums">Char a[]=”abcdefg”;</pre>
</div></li></ol>
<p>如指针相反，由字符串常量初始化的数组是可以修改的。其中的单个字符在以后可以改变。</p>
<p>下面是一个在vc6中的一个例子，完成将一个字符串中的所有大写字母全部转换为小写字母的功能：</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;
#include&lt;ctype.h&gt;
using namespace std;
/******************************************************************************/
/*
*    Convert a string to lower case
*/  

int strlower(char *string)
{
    if(string==NULL)
    {
    ;
    }
    while(*string)
    {
        if(isupper(*string))
        *string=tolower(*string);
        string++;
    }
    *string='\0';
    ;
}
/*
char *strlower(char *string)
{
    char *s;
    if(string == NULL)
    {
        return NULL;
    }
    s = string;
    while(*s)
    {
        if(isupper(*s))
        {
            *s = (char) tolower(*s);
        }
        s++;
    }
    *s = '\0';
    return string;
}
*/
void main()
{
    char *test="ABCDEFGhijklmN";
    strlower(test);
    cout&lt;&lt;test&lt;&lt;endl;
}</pre>
</div>
<p>其中，如果采用char *test=”ABCDEFGhijklmN”;会产生运行时错误。Char test[]=”ABCDEFGhijklmN”则程序正常运行，原因如前所述。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gmzz49.html">&lbrack;LeetCode&rsqb; Super Ugly Number 超级丑陋数</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mnvlrq.html">HTML 字符实体 &amp;amp&semi;lt&semi; &amp;amp&semi;gt&colon; &amp;amp&semi;amp&semi;等</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8knmx38.html">ECMAScript 5中的数据属性和访问器属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jndol8.html">【皇甫】☀ 图&lowbar;substring</a>
		</li>
						<li><a href="https://www.batexi.com/a/m962oznq.html">poj1733&lpar;种类并查集&plus;离散化&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g75lz9.html">shellcode流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xn1gn9.html">UI4&lowbar;UITableViewEdit</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wr3j8.html">利用mmap &sol;dev&sol;mem 读写Linux内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1l6z19.html">可发布指定的ASP&period;NET页面的插件：LimusicAddin</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmx6yx9.html">hdu 4570 Multi-bit Trie 区间DP入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zzkde9.html">DapperLambda发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppw739.html">eclipse 配置android sdk和maven</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey52xx9.html">Grunt那些事</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjyzdk8.html">css颜色值设置方式有哪些？以及如何随机一个颜色&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk306j8.html">mysql 存储ip地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gennp48.html">python&mdash;&mdash;&mdash;day1</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wgxmnq.html">Python 程序下载经办人照片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1z4g5q.html">&lbrack;Linux&rsqb;&period;deb软件包：wine-qq2013-longeneteam安装与卸载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5eeymq.html">idea spring-boot gradle mybatis 搭建开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj03lxq.html">拥抱函数式编程 I - 基本概念</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z1w5439.html">黑马程序员&lowbar;Java面向对象&lowbar;内部类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1w5pn9.html">linux虚拟机命令行模式下，某些命令显示乱码问题。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6e4x9.html">关于bootstrap--表单（水平表单）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1zede9.html">Android Studio：You need to use a Theme&period;AppCompat theme &lpar;or descendant&rpar; with this activity&period;  AlertDialog</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z10yvv9.html">网络直播电视之M3U8解析篇 （下）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjlmjk9.html">KVO详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ov7039.html">WebApi2官网学习记录---JSON与XML的序列化</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd3rgr8.html">hdu1087 简单DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ovyrv9.html">poj2709  贪心基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xm31n9.html">火狐Ｆｉｒｅｆｏｘ　浏览器　onblur（）　并且ａｌｅｒｔ（）时文本被选中问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
